package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.Spice;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author leon on 27/12/2018.
 */
public class Food {
    private List<Spice> spices;
    private Map<Class<? extends Spice>, Integer> spiceCount;

    public Food() {
        this.spices = new ArrayList<>();
        this.spiceCount = new HashMap<>();
    }

    public List<Spice> getAllSpices() {
        return spices;
    }

    public <SpiceType extends Class<? extends Spice>> Map<SpiceType, Integer> getSpiceCount() {
        for (Spice spice : spices) {
            Integer count = this.spiceCount.getOrDefault(spice.getClass(), 0);
            spiceCount.put(spice.getClass(), count + 1);
        }
        return (Map<SpiceType, Integer>) spiceCount;
    }

    public void applySpice(Spice spice) {
        this.spices.add(spice);
    }
}
