package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        StringBuilder sb = new StringBuilder();
        return sb.append(str, 0, str.length()/2)
                .append(getMiddleCharacter(str).toString().toUpperCase())
                .append(str.substring((str.length()/2)+1))
                .toString();
    }

    public static String lowerCaseMiddleCharacter(String str) {
        StringBuilder sb = new StringBuilder();
        return sb.append(str, 0, str.length()/2)
                .append(getMiddleCharacter(str).toString().toLowerCase())
                .append(str.substring((str.length()/2)+1))
                .toString();
    }

    public static Boolean isIsogram(String str) {
        Boolean isIsogram = true;
        Set<Character> characterSet = new HashSet<>();
        for (int i = 0; i < str.length(); i++) {
            if (!isIsogram) break;
            isIsogram = characterSet.add(str.charAt(i));
        }
        return isIsogram;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        for (int i = 1; i < str.length(); i++) if (str.charAt(i) == str.charAt(i-1)) return true;
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        return str.replaceAll("/[^\\w\\s]|(.)\\1", "");
    }

    public static String invertCasing(String str) {
        char[] characters = str.toCharArray();
        for (int i = 0; i < characters.length; i++) {
            if (Character.isUpperCase(characters[i]))
                characters[i] = Character.toLowerCase(characters[i]);
            else characters[i] = Character.toUpperCase(characters[i]);
        }
        return new String(characters);
    }
}